# Copyright (c) 2003 Chalmers University of Technology
# Authors: Jean-Marc Orliaguet <jmo@ita.chalmers.se>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 2 as published
# by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
# 02111-1307, USA.
#

"""
  Area Shape
"""

from Globals import InitializeClass
from AccessControl import ClassSecurityInfo

from Products.CMFCore.CMFCorePermissions import View, ModifyPortalContent


from BaseStyle import BaseStyle


def addAreaShape(dispatcher, id, REQUEST=None, **kw):
    """Add an Area Shape."""
    ob = AreaShape(id, **kw)
    dispatcher._setObject(id, ob)
    if REQUEST is not None:
        url = dispatcher.DestinationURL()
        REQUEST.RESPONSE.redirect('%s/manage_main' % url)


factory_type_information = (
    {'id': 'Area Shape',
     'title': 'Area Shape',
     'description': ('Area Shape'),
     'meta_type': 'Area Shape',
     'icon': 'area_shape.gif',
     'product': 'CPSSkins',
     'factory': 'addAreaShape',
     'immediate_view': 'cpsskins_edit_form',
     'filter_content_types': 0,
     'global_allow': 0,
     'actions': BaseStyle._actions +
                (
                 {'id': 'render',
                  'name': 'Render',
                  'action': 'cpsskins_areashape',
                  'visible': 0,
                  'permissions': (View,)},
                 {'id': 'preview',
                  'name': 'Preview',
                  'action': 'cpsskins_areashape_preview',
                  'visible': 0,
                  'permissions': (View,)
		 },
                 {'id': 'list',
                  'name': 'List',
                  'action': 'cpsskins_listAreaShapes',
                  'visible': 0,
                  'permissions': (View,)
                 },
                 ),
     },
    )


class AreaShape(BaseStyle):
    """
    Area Shape.
    """

    meta_type = 'Area Shape'
    portal_type = 'Area Shape'

    security = ClassSecurityInfo()

    _properties = BaseStyle._properties + (
        {'id': 'Area_border_style', 
         'type': 'string', 
         'mode': 'w', 
         'label': 'Area border style', 
         'palette': 'Palette Border'},
        {'id': 'Area_border_width', 
         'type': 'string', 
         'mode': 'w', 
         'label': 'Area border width'},
        )

    def __init__(self, id, 
                       Area_border_style = 'solid',
                       Area_border_width = '1px',
		       **kw):
        apply(BaseStyle.__init__, (self, id), kw)
	self.Area_border_style = Area_border_style
	self.Area_border_width = Area_border_width

InitializeClass(AreaShape)

