from Products.CMFCore.utils import getToolByName

COMMON_ACTIONS = \
( { 'category'              : 'global'
  , 'action_id'             : 'globalboxes'
  , 'title'                 : 'Global boxes'
  , 'priority'              : 0
  , 'icon_expr'             : 'cpsskins_images/action_globalboxes-16x16.gif'
  }
, { 'category'              : 'global'
  , 'action_id'             : 'configPortal'
  , 'title'                 : 'Portacl Configuration'
  , 'priority'              : 0
  , 'icon_expr'             : 'cpsskins_images/action_configPortal-16x16.gif'
  }
, { 'category'              : 'global'
  , 'action_id'             : 'directories'
  , 'title'                 : 'Directories'
  , 'priority'              : 0
  , 'icon_expr'             : 'cpsskins_images/action_directories-16x16.gif'
  }
, { 'category'              : 'global'
  , 'action_id'             : 'configThemes'
  , 'title'                 : 'Portal Themes'
  , 'priority'              : 0
  , 'icon_expr'             : 'cpsskins_images/action_configThemes-16x16.gif'
  }
,
  { 'category'              : 'user'
  , 'action_id'             : 'login'
  , 'title'                 : 'Login'
  , 'priority'              : 0
  , 'icon_expr'             : 'cpsskins_images/action_login-16x16.gif'
  }
, { 'category'              : 'user'
  , 'action_id'             : 'logout'
  , 'title'                 : 'Logout'
  , 'priority'              : 0
  , 'icon_expr'             : 'cpsskins_images/action_logout-16x16.gif'
  }
, { 'category'              : 'user'
  , 'action_id'             : 'personalboxes'
  , 'title'                 : 'My boxes'
  , 'priority'              : 0
  , 'icon_expr'             : 'cpsskins_images/action_personalboxes-16x16.gif'
  }
)

DEFAULT_MAPPINGS = ( COMMON_ACTIONS
                   )


def install(self, mappings=DEFAULT_MAPPINGS):
   portal = self.portal_url.getPortalObject()
                                              
   log = []
   pr = log.append

   def pr_h3(msg, pr=pr):
        pr('<h3>%s</h3>' % msg)

   def portalhas(id, portal=portal):         
      return id in portal.objectIds()

   if portalhas('portal_actionicons'):
      aitool = getToolByName(self, 'portal_actionicons' )

      pr("<pre>")
      pr_h3('Action icons')

      pr(' Installing action icons')
      for mapping in mappings:
          try:
             aitool.addActionIcon( category=mapping[ 'category' ]
                              , action_id=mapping[ 'action_id' ]
                              , icon_expr=mapping[ 'icon_expr' ]
                              , title=mapping[ 'title' ]
                              , priority=mapping[ 'priority' ]
                              )
          except KeyError:
             pr(' - ' + mapping['category'] + '/' + mapping['action_id'] \
                      + ' (already installed)')
          else:
             pr(' - ' + mapping['category'] + '/' + mapping['action_id'] )
             

      pr("</pre>")

   return '\n'.join(log)
