# Copyright (c) 2003 Chalmers University of Technology
# Authors: Jean-Marc Orliaguet <jmo@ita.chalmers.se>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 2 as published
# by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
# 02111-1307, USA.
#

"""
  Palette Color
"""

from Globals import InitializeClass
from AccessControl import ClassSecurityInfo

from Products.CMFCore.CMFCorePermissions import View, ModifyPortalContent


from BasePalette import BasePalette


def addPaletteColor(dispatcher, id, REQUEST=None, **kw):
    """Add an Palette Color."""
    ob = PaletteColor(id, **kw)
    dispatcher._setObject(id, ob)
    if REQUEST is not None:
        url = dispatcher.DestinationURL()
        REQUEST.RESPONSE.redirect('%s/manage_main' % url)


factory_type_information = (
    {'id': 'Palette Color',
     'title': 'Palette Color',
     'description': ('Palette Color'),
     'meta_type': 'Palette Color',
     'icon': 'palette_color.gif',
     'product': 'CPSSkins',
     'factory': 'addPaletteColor',
     'immediate_view': 'cpsskins_edit_form',
     'filter_content_types': 0,
     'global_allow': 0,
     'actions': BasePalette._actions +
                (
                 {'id': 'preview',
                  'name': 'Preview',
                  'action': 'cpsskins_palettecolor_preview',
                  'visible': 0,
                  'permissions': (View,)},
                 ),
     },
    )


class PaletteColor(BasePalette):
    """
    Palette Color.
    """
    meta_type = 'Palette Color'
    portal_type = 'Palette Color'

    security = ClassSecurityInfo()

    _properties = BasePalette._properties + (
        {'id': 'value', 'type': 'string', 'mode': 'w', 'label': 'Color'},
        )


    def __init__(self, id, 
                       value = '#CCCCCC',
		       **kw):
        apply(BasePalette.__init__, (self, id), kw)
	self.value = value


InitializeClass(PaletteColor)

