# Copyright (c) 2003 Chalmers University of Technology
# Authors: Jean-Marc Orliaguet <mailto:jmo@ita.chalmers.se>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 2 as published
# by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
# 02111-1307, USA.
#

import sys
from Products.CMFCore import utils
from Products.CMFCore.CMFCorePermissions import AddPortalContent
from Products.CMFCore.DirectoryView import registerDirectory

from Products.CPSSkins import BaseTemplet

import CollapsibleMenu
import CollapsibleMenuStyle

this_module = sys.modules[__name__]

templetClasses = ( CollapsibleMenu.CollapsibleMenu, )
styleClasses = ( CollapsibleMenuStyle.CollapsibleMenuStyle, )

contentConstructors = ( CollapsibleMenu.addCollapsibleMenu, 
                        CollapsibleMenuStyle.addCollapsibleMenuStyle, )

fti = (CollapsibleMenu.factory_type_information + 
       CollapsibleMenuStyle.factory_type_information + 
       ()
      )

contentClasses = templetClasses + styleClasses
bases = contentClasses 

this_module = sys.modules[__name__]
z_bases = utils.initializeBasesPhase1(bases, this_module)

registerDirectory('skins', globals())

def initialize(registrar):
    utils.initializeBasesPhase2(z_bases, registrar)
    utils.ContentInit(
        'CPSSkins Collapsible Menu Content',
        content_types = contentClasses,
        permission = AddPortalContent,
        extra_constructors = contentConstructors,
        fti = fti,
        ).initialize(registrar)

    utils.registerIcon(CollapsibleMenu.CollapsibleMenu, 'skins/collapsiblemenu.gif', globals())
    utils.registerIcon(CollapsibleMenuStyle.CollapsibleMenuStyle, 'skins/collapsiblemenu_style.gif', globals())


